QwtPolarSpectrogram(3)

NAME
QwtPolarSpectrogram - An item, which displays a spectrogram.

SYNOPSIS

#include <qwt_polar_spectrogram.h>

Inherits QwtPolarItem.

  Public Types
enum PaintAttribute { ApproximatedAtan = 0x01 }
typedef QFlags< PaintAttribute > PaintAttributes

  Public Member Functions
QwtPolarSpectrogram ()
Constructor.
virtual ~QwtPolarSpectrogram ()
Destructor.
void setData (QwtRasterData *data)
const QwtRasterData * data () const
void setColorMap (QwtColorMap *)
const QwtColorMap * colorMap () const
void setPaintAttribute (PaintAttribute, bool on=true)
bool testPaintAttribute (PaintAttribute) const
virtual int rtti () const override
virtual void draw (QPainter *painter, const QwtScaleMap &azimuthMap, const QwtScaleMap &radialMap, const QPointF &pole, double radius, const QRectF &canvasRect) const override
virtual QwtInterval boundingInterval (int scaleId) const override

  Protected Member Functions
virtual QImage renderImage (const QwtScaleMap &azimuthMap, const QwtScaleMap &radialMap, const QPointF &pole, const QRect &rect) const
Render an image from the data and color map.
virtual void renderTile (const QwtScaleMap &azimuthMap, const QwtScaleMap &radialMap, const QPointF &pole, const QPoint &imagePos, const QRect &tile, QImage *image) const
Render a sub-rectangle of an image.

Detailed Description

An item, which displays a spectrogram. A spectrogram displays 3-dimensional data, where the 3rd dimension ( the intensity ) is displayed using colors. The colors are calculated from the values using a color map.

See also
    QwtRasterData, QwtColorMap

Definition at line 28 of file qwt_polar_spectrogram.h.

Member Typedef Documentation

  typedef QFlags<PaintAttribute > QwtPolarSpectrogram::PaintAttributes
An ORed combination of PaintAttribute values.

Definition at line 47 of file qwt_polar_spectrogram.h.

Member Enumeration Documentation

  enum QwtPolarSpectrogram::PaintAttribute
Attributes to modify the drawing algorithm. The default setting disables ApproximatedAtan

See also
    setPaintAttribute(), testPaintAttribute()

Enumerator

ApproximatedAtan
    Use qwtFastAtan2 instead of atan2 for translating widget into polar coordinates.

Definition at line 37 of file qwt_polar_spectrogram.h.

Member Function Documentation

  QwtInterval QwtPolarSpectrogram::boundingInterval (int scaleId) const [override], [virtual]
Interval, that is necessary to display the item This interval can be useful for operations like clipping or autoscaling

Parameters
    scaleId Scale index

Returns
    bounding interval ( == position )

See also
    position()

Reimplemented from QwtPolarItem.

Definition at line 443 of file qwt_polar_spectrogram.cpp.

  const QwtColorMap * QwtPolarSpectrogram::colorMap () const

Returns
    Color Map used for mapping the intensity values to colors

See also
    setColorMap()

Definition at line 137 of file qwt_polar_spectrogram.cpp.

  const QwtRasterData * QwtPolarSpectrogram::data () const

Returns
    Spectrogram data

See also
    setData()

Definition at line 106 of file qwt_polar_spectrogram.cpp.

  void QwtPolarSpectrogram::draw (QPainter * painter, const QwtScaleMap & azimuthMap, const QwtScaleMap & radialMap, const QPointF & pole, double radius, const QRectF & canvasRect) const [override], [virtual]
Draw the spectrogram

Parameters
    painter Painter
    azimuthMap Maps azimuth values to values related to 0.0, M_2PI
    radialMap Maps radius values into painter coordinates.
    pole Position of the pole in painter coordinates
    radius Radius of the complete plot area in painter coordinates
    canvasRect Contents rect of the canvas in painter coordinates

Implements QwtPolarItem.

Definition at line 177 of file qwt_polar_spectrogram.cpp.

  QImage QwtPolarSpectrogram::renderImage (const QwtScaleMap & azimuthMap, const QwtScaleMap & radialMap, const QPointF & pole, const QRect & rect) const [protected], [virtual]

Render an image from the data and color map. The area is translated into a rect of the paint device. For each pixel of this rect the intensity is mapped into a color.

Parameters
    azimuthMap Maps azimuth values to values related to 0.0, M_2PI
    radialMap Maps radius values into painter coordinates.
    pole Position of the pole in painter coordinates
    rect Target rectangle of the image in painter coordinates

Returns
    A QImage::Format_Indexed8 or QImage::Format_ARGB32 depending on the color map.

See also
    QwtRasterData::intensity(), QwtColorMap::rgb(), QwtColorMap::colorIndex()

Definition at line 235 of file qwt_polar_spectrogram.cpp.

  void QwtPolarSpectrogram::renderTile (const QwtScaleMap & azimuthMap, const QwtScaleMap & radialMap, const QPointF & pole, const QPoint & imagePos, const QRect & tile, QImage * image) const [protected], [virtual]

Render a sub-rectangle of an image. renderTile() is called by renderImage() to render different parts of the image by concurrent threads.

Parameters
    azimuthMap Maps azimuth values to values related to 0.0, M_2PI
    radialMap Maps radius values into painter coordinates.
    pole Position of the pole in painter coordinates
    imagePos Top/left position of the image in painter coordinates
    tile Sub-rectangle of the tile in painter coordinates
    image Image to be rendered

See also
    setRenderThreadCount()

Note
    renderTile needs to be reentrant

Definition at line 343 of file qwt_polar_spectrogram.cpp.

  int QwtPolarSpectrogram::rtti () const [override], [virtual]

Returns
    QwtPolarItem::Rtti_PolarSpectrogram

Reimplemented from QwtPolarItem.

Definition at line 76 of file qwt_polar_spectrogram.cpp.

  void QwtPolarSpectrogram::setColorMap (QwtColorMap * colorMap)
Change the color map

Often it is useful to display the mapping between intensities and colors as an additional plot axis, showing a color bar.

Parameters
    colorMap Color Map

See also
    colorMap(), QwtScaleWidget::setColorBarEnabled(), QwtScaleWidget::setColorMap()

Definition at line 122 of file qwt_polar_spectrogram.cpp.

  void QwtPolarSpectrogram::setData (QwtRasterData * data)
Set the data to be displayed

Parameters
    data Spectrogram Data

See also
    data()

Warning
    QwtRasterData::initRaster() is called each time before the image is rendered, but without any useful parameters. Also QwtRasterData::rasterHint() is not used.

Definition at line 91 of file qwt_polar_spectrogram.cpp.

  void QwtPolarSpectrogram::setPaintAttribute (PaintAttribute attribute, bool on = true)
Specify an attribute how to draw the curve

Parameters
    attribute Paint attribute
    on On/Off

See also
    testPaintAttribute()

Definition at line 149 of file qwt_polar_spectrogram.cpp.

  bool QwtPolarSpectrogram::testPaintAttribute (PaintAttribute attribute) const

Parameters
    attribute Paint attribute

Returns
    True, when attribute has been set

See also
    setPaintAttribute()

Definition at line 162 of file qwt_polar_spectrogram.cpp.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.